const spawn = require('child_process').spawn;

class Spawn {
  constructor(command) {

    // linux
    this.child = spawn('/bin/sh',
      ['-c', command],
      {
        cwd: null,
        env: null,
        windowsVerbatimArguments: false
      })

    // TODO windows
    // this.child = require('child_process').spawn(
    //   'cmd.exe',
    //   ['/s', '/c', command],
    //   {
    //     cwd: null,
    //     env: null,
    //     windowsVerbatimArguments: true
    //   }
    // );
  }

  onData(func) {
    this.child.stdout.on('data', (str) => {
      func('' + str)
    });

    this.child.stderr.on('data', (str) => {
      func('' + str)
    });
  }

  onClose(func) {
    this.child.on('close', func);
  }
}

module.exports = Spawn
